From: Dmitry Shachnev <mitya57@gmail.com>
Date: Mon, 1 Feb 2016 00:05:30 +0300
Subject: [PATCH] Set __qualname__ equal to __name__ on derived classes

To make output on Python ≥ 3.5 the same as on previous Python versions.

This fixes #928.

Patch-Source: https://github.com/nose-devs/nose/pull/983

index 42f8563d..13d0c8a2 100644
--- a/functional_tests/test_load_tests_from_test_case.py
+++ b/functional_tests/test_load_tests_from_test_case.py
@@ -29,6 +29,7 @@ def setUp(self):
                 pass
             def tearDown(self):
                 pass
+        Derived.__qualname__ = Derived.__name__
         # must use nose loader here because the default loader in 2.3
         # won't load tests from base classes
         l = loader.TestLoader()
index bfe16589..80ab1d4e 100644
--- a/nose/util.py
+++ b/nose/util.py
@@ -643,6 +643,7 @@ class C(cls):
         pass
     C.__module__ = module
     C.__name__ = cls.__name__
+    C.__qualname__ = cls.__name__
     return C
 
 
index 944d2859..261436b0 100644
--- a/unit_tests/test_xunit.py
+++ b/unit_tests/test_xunit.py
@@ -16,6 +16,7 @@ def mktest():
     class TC(unittest.TestCase):
         def runTest(self):
             pass
+    TC.__qualname__ = TC.__name__
     test = TC()
     return test
